package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.apache.bcel.classfile.ConstantCP;
import org.apache.bcel.classfile.ConstantNameAndType;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.generic.CPInstruction;
import org.apache.bcel.generic.ConstantPoolGen;

public abstract class NameSignatureInstruction extends CPInstruction {
  public NameSignatureInstruction() {}
  
  public NameSignatureInstruction(short opcode, int index) {
    super(opcode, index);
  }
  
  public String getName(ConstantPoolGen cpg) {
    ConstantPool cp = cpg.getConstantPool();
    ConstantNameAndType cnat = getNameAndType(cpg);
    return ((ConstantUtf8)cp.getConstant(cnat.getNameIndex())).getBytes();
  }
  
  public ConstantNameAndType getNameAndType(ConstantPoolGen cpg) {
    ConstantPool cp = cpg.getConstantPool();
    ConstantCP cmr = (ConstantCP)cp.getConstant(getIndex());
    return (ConstantNameAndType)cp.getConstant(cmr.getNameAndTypeIndex());
  }
  
  public String getSignature(ConstantPoolGen cpg) {
    ConstantPool cp = cpg.getConstantPool();
    ConstantNameAndType cnat = getNameAndType(cpg);
    return ((ConstantUtf8)cp.getConstant(cnat.getSignatureIndex())).getBytes();
  }
}
